# Coveo SearchAlerts Component (CoveoSearchAlerts)

The Search Alerts component renders items in the Settings menu that allow the end user to follow queries and to manage search alerts. A user following a query receives email notifications when the query results change.

Note:

> It is necessary to meet certain requirements to be able to use this component (see Deploying Search Alerts on a Coveo JS Search Page).

See also the FollowItem component.

## Index

### Methods

- debugInfo
- disable
- enable
- followQuery
- getBindings
- openPanel
- get

### Properties

- bind
- componentOptionsModel
- componentStateModel
- disabled
- logger
- message
- queryController
- queryStateModel
- root
- searchInterface
- ID

### Accessors

- usageAnalytics

### Component Options

- enableFollowQuery
- enableManagePanel
- enableMessage
- messageCloseDelay
- modifiedDateField

### Constructors

- constructor

## Methods

### debugInfo

- debugInfo(): any

- Inherited from BaseComponent.debugInfo

  - Defined in ui/Base/BaseComponent.ts :41

  Return the debug info about this component.

  #### Returns any

### disable

- disable(): void

- Inherited from BaseComponent.disable

  - Defined in ui/Base/BaseComponent.ts :52

  Disable the component. Normally this means that the component will not execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### enable

- enable(): void

- Inherited from BaseComponent.enable

  - Defined in ui/Base/BaseComponent.ts :61

  Enable the component. Normally this means that the component will execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### followQuery

- followQuery(): void

- - Defined in ui/SearchAlerts/SearchAlerts.ts :205

  Follows the last query. The user will start receiving email notifications when the query results change.

  Also logs the `searchAlertsFollowQuery` event in the usage analytics with the name of the request as meta data.

  #### Returns void

### getBindings

- getBindings(): IComponentBindings

- Inherited from Component.getBindings

  - Defined in ui/Base/Component.ts :328

  Return the bindings, or environment, for the current component.

  #### Returns IComponentBindings

### openPanel

- openPanel(): Promise<void>

- - Defined in ui/SearchAlerts/SearchAlerts.ts :240

  Opens the Manage Alerts panel. This panel allows the end user to stop following queries or items. It also allows the end user to specify email notification frequency for each followed query or item.

  #### Returns Promise<void>

### Static get

- get(element: HTMLElement, componentClass?: any, noThrow?: boolean): BaseComponent

- Inherited from Component.get

  - Defined in ui/Base/Component.ts :410

  Get the bound component to the given HTMLElement. Throws an assert if the HTMLElement has no component bound, unless using the noThrow argument.
  If there is multiple component bound to the current HTMLElement, you must specify the component class.

  #### Parameters

  - ##### element: HTMLElement

    HTMLElement for which to get the bound component.

  - ##### Optional componentClass: any

    Optional component class. If the HTMLElement has multiple components bound, you must specify which one you are targeting.

  - ##### Optional noThrow: boolean

    Boolean option to tell the method to not throw on error.

  #### Returns BaseComponent

## Properties

### bind

bind: ComponentEvents

Inherited from Component.bind

- Defined in ui/Base/Component.ts :270

Allows the component to bind events and execute them only when it is enabled.

type

  {Coveo.ComponentEvents}

### componentOptionsModel

componentOptionsModel: ComponentOptionsModel

Inherited from Component.componentOptionsModel

- Defined in ui/Base/Component.ts :294

Contains the state of options for different components. Mainly used by ResultLink.

### componentStateModel

componentStateModel: ComponentStateModel

Inherited from Component.componentStateModel

- Defined in ui/Base/Component.ts :282

Contains the state of different components (enabled vs disabled). Allows to get/set values. Triggers component state event when modified. Each component can listen to those events.

### disabled

disabled: boolean

Inherited from BaseComponent.disabled

- Defined in ui/Base/BaseComponent.ts :23

A disabled component will not participate in the query, or listen to ComponentEvents.

type

  {boolean}

### logger

logger: Logger

Inherited from BaseComponent.logger

- Defined in ui/Base/BaseComponent.ts :18

Allows component to log in the dev console.

### message

message: SearchAlertsMessage

- Defined in ui/SearchAlerts/SearchAlerts.ts :125

A reference to a SearchAlertsMessage component that the SearchAlerts component uses to display messages.

### queryController

queryController: QueryController

Inherited from Component.queryController

- Defined in ui/Base/Component.ts :286

Contains the singleton that allows to trigger queries.

### queryStateModel

queryStateModel: QueryStateModel

Inherited from Component.queryStateModel

- Defined in ui/Base/Component.ts :278

Contains the state of the query. Allows to get/set values. Trigger query state event when modified. Each component can listen to those events.

### root

root: HTMLElement

Inherited from Component.root

- Defined in ui/Base/Component.ts :274

A reference to the root HTMLElement (the SearchInterface).

### searchInterface

searchInterface: SearchInterface

Inherited from Component.searchInterface

- Defined in ui/Base/Component.ts :290

A reference to the root of every component, the SearchInterface.

### Static ID

ID: string

Inherited from BaseComponent.ID

- Defined in ui/Base/BaseComponent.ts :28

The static ID that each component needs in order to be identified.
For example, SearchButton -> static ID: SearchButton -> className: CoveoSearchButton

## Accessors

### usageAnalytics

- get (): IAnalyticsClient

- Inherited from Component.usageAnalytics

  - Defined in ui/Base/Component.ts :343

  A reference to the Analytics.client.

  #### Returns IAnalyticsClient

## Component Options

### enableFollowQuery

enableFollowQuery: boolean

- Defined in ui/SearchAlerts/SearchAlerts.ts :89

Specifies whether to add the Follow Query item in the Settings menu to allow the end user to follow the last query.

Clicking the Follow Query item calls the SearchAlerts.followQuery method.

Default value is `true`.

Default

  `true`

Markup configuration example(s) :

    data-enable-follow-query='true'
    data-enable-follow-query='false'

### enableManagePanel

enableManagePanel: boolean

- Defined in ui/SearchAlerts/SearchAlerts.ts :79

Specifies whether to add the Manage Alerts item in the Settings menu to allow the end user to manage search alerts.

Clicking the Manage Alerts item calls the SearchAlerts.openPanel method.

Default value is `true`.

Default

  `true`

Markup configuration example(s) :

    data-enable-manage-panel='true'
    data-enable-manage-panel='false'

### enableMessage

enableMessage: boolean

- Defined in ui/SearchAlerts/SearchAlerts.ts :109

Specifies whether to display info and error messages when performing search alerts actions.

If this options is `true`, the SearchAlerts constructor will automatically instantiate a SearchAlertsMessage component and set it to the SearchAlerts.message attribute.

See also SearchAlerts.options.messageCloseDelay.

Default value is `true`.

Default

  `true`

Markup configuration example(s) :

    data-enable-message='true'
    data-enable-message='false'

### messageCloseDelay

messageCloseDelay: number

- Defined in ui/SearchAlerts/SearchAlerts.ts :117

If SearchAlerts.options.enableMessage is `true`, specifies how long to display the search alert messages (in milliseconds).

Default value is `2000`. Minimum value is `0`.

Only effective when

  `enableMessage` is truthy

Minimum

  `0`

Default

  `2000`

Markup configuration example(s) :

    data-message-close-delay='10'

### modifiedDateField

modifiedDateField: IFieldOption

- Defined in ui/SearchAlerts/SearchAlerts.ts :97

Specifies which field to use to represent the modification date when sending the ISubscriptionQueryRequest.

Default value is `undefined`.

Markup configuration example(s) :

    data-modified-date-field='@foo'

## Constructors

### constructor

- new SearchAlerts(element: HTMLElement, options: ISearchAlertsOptions, bindings?: IComponentBindings, ModalBox?: any): SearchAlerts

- Overwrites Component.constructor

  - Defined in ui/SearchAlerts/SearchAlerts.ts :125

  Creates a new SearchAlerts component.

  #### Parameters

  - ##### element: HTMLElement

    The HTMLElement on which to instantiate the component.

  - ##### options: ISearchAlertsOptions

    The options for the SearchAlerts component.

  - ##### Optional bindings: IComponentBindings

    The bindings that the component requires to function normally. If not set, these will be automatically resolved (with a slower execution time).

  - ##### Default value ModalBox: any = ModalBoxModule

  #### Returns SearchAlerts